//******************************************************************************
//  Lab 2 I/O Exercise - Respond to button-press interrupt in P1.0 and toggle
//                       LED on P2.1.
//
//  Instructions:
//   Complete the code below to configure P1.0 as in interrupt enabled interrupt
//
//   - Set applicable P2DIR bit for P2.1 as output for the LED
//   - Set applicable P1IE bits to enable interrupt for P1.0
//   - Set applicable P1IES bits for interrupt on H-L transition for P1.0
//   - Clear interrupt flag in ISR.
//
//   As you work with the lab, explore CCS, set breakpoints, open
//   register windows, etc.
//
//
//           MSP430FG461x
//         ---------------
//     /|\|            XIN|-
//      | |               | 32kHz
//      --|RST        XOUT|-
//        |               |
//        |           P2.1|-->LED (toggle when SW1 pressed)
//
//******************************************************************************
#include <msp430xG46x.h>

void main(void)
{
  WDTCTL = WDTPW + WDTHOLD; // Stop WDT
  FLL_CTL0 |= XCAP14PF;     // Configure load caps
  P2DIR = ????;             // Set P2.1 to output direction
  P1IES = ????;             // H-L transition
  P1IE = ????;              // Enable interrupt
  _EINT();                  // Enable interrupts
  while (1);
}

// P1 interrupt service routine
#pragma vector=PORT1_VECTOR
__interrupt void P1ISR (void)
{
  unsigned volatile int i;
  for (i=0; i<10000; ++i);  // Debounce delay
  P1IFG &= ~????;           // Clear P1IFG
  if ((P1IN & 0x01) == 0)
    P2OUT ^= 0x02;           // Toggle P2.1 using exclusive-OR
}

