//****************************************************************************
//  Lab 5 - TA: Configure TA for a one-second interrupt
//
//  Instructions:
//   Complete the code below to configure Timer_A to give a 1s interrupt
//
//   - Set applicable TACTL bits to configure clock source and clear timer
//   - Set applicable bits in TACCTL0 for compare mode, interrupt enabled
//   - Load TACCR0 with #of counts to give 1s interrupt
//
//
//
//           MSP430FG4619
//         ---------------
//     /|\|            XIN|-
//      | |               | 32kHz
//      --|RST        XOUT|-
//        |               |
//        |           P2.1|-->LED (toggle at 1 second interval)
//
//******************************************************************************
#include <msp430xG46x.h>

void main(void)
{
  WDTCTL = WDTPW + WDTHOLD;                 // Stop WDT
  FLL_CTL0 |= XCAP14PF;                     // Configure load caps
  P2DIR |= BIT1;                            // Set P2.1 to output direction
  TACTL = ________________;                 // Clock = ACLK (32768), clear
  TACCTL0 = ____;                           // CCR0 interrupt enabled
  TACCR0 = _______;                         // #counts for 1s
  TACTL |= ____;                            // Setting mode bits starts timer

  _BIS_SR(LPM3_bits + GIE);                 // Enter LPM3 w/ interrupt
}

// Timer A0 interrupt service routine
#pragma vector=TIMERA0_VECTOR
__interrupt void Timer_A (void)
{
    P2OUT ^= 0x02;                          // Toggle P2.1 using exclusive-OR
}

