//******************************************************************************
//  Lab 3 Low-Power Solution - Convert Lab2 from always-on to LPM3
//
//  Instructions:
//    - Download the code and measure the current consumption
//
//   As you work with the lab, explore IAR Kickstart, set breakpoints, open
//   register windows, etc.
//
//
//           MSP430FG4619
//         ---------------
//     /|\|            XIN|-
//      | |               | 32kHz
//      --|RST        XOUT|-
//        |               |
//        |           P2.1|-->LED (toggle when SW1 pressed)
//
//******************************************************************************
#include <msp430xG46x.h>

void main(void)
{
  WDTCTL = WDTPW + WDTHOLD; // Stop WDT
  FLL_CTL0 |= XCAP14PF;     // Configure load caps

// Configure all I/O as outputs, low.
  P1DIR = (0xff & ~(BIT0+BIT1));   // P1.0, P1.1 input, others output
  P1OUT = 0;
  P2DIR = (0xff & ~BIT5);  // P2.5 must be input
  P2OUT = 0;
  P3DIR = (0xff & ~BIT5);  // P3.5 must be high
  P3OUT = (BIT1 + BIT2);   // '2013 could possibly tied these high
  P4DIR = 0xff;
  P4OUT = 0;
  P5DIR = 0xff;
  P5OUT = 0;
  P6DIR = 0xff;
  P6OUT = 0;
  P7DIR = 0xff;
  P7OUT = 0;
  P8DIR = 0xff;
  P8OUT = 0;
  P9DIR = 0xff;
  P9OUT = 0;
  P10DIR = 0xff;
  P10OUT = 0;

  P1IES = BIT0;             // H-L transition
  P1IE = BIT0;              // Enable intererupt
  _EINT();                  // Enable interrupts

  while(1)
  {
    _BIS_SR(LPM3_bits);     // Enter LPM3
    if ((P1IN & 0x01) == 0)
      P2OUT ^= 0x02;        // Toggle P2.1 using exclusive-OR
  }
}

// P1 interrupt service routine
#pragma vector=PORT1_VECTOR
__interrupt void P1ISR (void)
{
  unsigned volatile int i;
  for (i=10000; i>0; i--);  // Debounce delay
  P1IFG &= ~BIT0;           // Clear P1IFG
  _BIC_SR_IRQ(LPM3_bits);   // Clear LPM3 bits from 0(SR)
}

